<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCabecInternosERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCabecInternosERP
 * @subpackage Arrays
 */
class ArrayOfCabecInternosERP extends AbstractStructArrayBase
{
    /**
     * The CabecInternosERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CabecInternosERP[]
     */
    public $CabecInternosERP;
    /**
     * Constructor method for ArrayOfCabecInternosERP
     * @uses ArrayOfCabecInternosERP::setCabecInternosERP()
     * @param \StructType\CabecInternosERP[] $cabecInternosERP
     */
    public function __construct(array $cabecInternosERP = array())
    {
        $this
            ->setCabecInternosERP($cabecInternosERP);
    }
    /**
     * Get CabecInternosERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CabecInternosERP[]|null
     */
    public function getCabecInternosERP()
    {
        return isset($this->CabecInternosERP) ? $this->CabecInternosERP : null;
    }
    /**
     * Set CabecInternosERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CabecInternosERP[] $cabecInternosERP
     * @return \ArrayType\ArrayOfCabecInternosERP
     */
    public function setCabecInternosERP(array $cabecInternosERP = array())
    {
        foreach ($cabecInternosERP as $arrayOfCabecInternosERPCabecInternosERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfCabecInternosERPCabecInternosERPItem instanceof \StructType\CabecInternosERP) {
                throw new \InvalidArgumentException(sprintf('The CabecInternosERP property can only contain items of \StructType\CabecInternosERP, "%s" given', is_object($arrayOfCabecInternosERPCabecInternosERPItem) ? get_class($arrayOfCabecInternosERPCabecInternosERPItem) : gettype($arrayOfCabecInternosERPCabecInternosERPItem)), __LINE__);
            }
        }
        if (is_null($cabecInternosERP) || (is_array($cabecInternosERP) && empty($cabecInternosERP))) {
            unset($this->CabecInternosERP);
        } else {
            $this->CabecInternosERP = $cabecInternosERP;
        }
        return $this;
    }
    /**
     * Add item to CabecInternosERP value
     * @throws \InvalidArgumentException
     * @param \StructType\CabecInternosERP $item
     * @return \ArrayType\ArrayOfCabecInternosERP
     */
    public function addToCabecInternosERP(\StructType\CabecInternosERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CabecInternosERP) {
            throw new \InvalidArgumentException(sprintf('The CabecInternosERP property can only contain items of \StructType\CabecInternosERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CabecInternosERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CabecInternosERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CabecInternosERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CabecInternosERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CabecInternosERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CabecInternosERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CabecInternosERP
     */
    public function getAttributeName()
    {
        return 'CabecInternosERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCabecInternosERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
